// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/Tileset.hpp"
#include "scene/components/display/mesh/QuadMeshHost.hpp"

#define TILED_SPRITE_FLIP_Y FLAG_DEFINE(1)
#define TILED_SPRITE_FLIP_X FLAG_DEFINE(2)

namespace Dawn {
  enum TiledSpriteSizeType {
    TILED_SPRITE_SIZE_TYPE_SCALE,
    TILED_SPRITE_SIZE_TYPE_WIDTH_RATIO,
    TILED_SPRITE_SIZE_TYPE_HEIGHT_RATIO
  };

  class TiledSprite : public SceneItemComponent {
    public:
      // @optional
      StateProperty<Tileset*> tileset;
      // @optional
      StateProperty<QuadMeshHost*> meshHost;
      // @optional
      StateProperty<int32_t> tile;
      // @optional
      StateProperty<flag_t> flip;
      // @optional
      StateProperty<enum TiledSpriteSizeType> sizeType;
      // @optional
      StateProperty<float_t> size;

      TiledSprite(SceneItem *item);
      std::vector<SceneItemComponent*> getDependencies();
      void onStart() override;
  };
}