// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "display/mesh/Mesh.hpp"

namespace Dawn {
  class MeshHost;

  class MeshRenderer : public SceneItemComponent {
    protected:
      MeshHost *meshHost = nullptr;

    public:
      // @optional
      Mesh * mesh = nullptr;

      /**
       * Constructs a MeshRenderer scene item component.
       * 
       * @param item Scene Item this mesh renderer belongs to.
       */
      MeshRenderer(SceneItem *item);

      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}