// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scenes/SceneMonologue.hpp"
#include "games/vn/events/VNDummyEvent.hpp"
#include "games/vn/events/VNSetDefaultFontEvent.hpp"
#include "games/vn/events/VNTextEvent.hpp"
#include "games/vn/events/VNChoiceEvent.hpp"
#include "games/vn/events/VNIfEvent.hpp"
#include "games/vn/events/VNSceneChangeEvent.hpp"
#include "games/vn/events/VNChoiceSetEvent.hpp"
#include "vnscenes/ScenePrologue9.hpp"

namespace Dawn {
  class ScenePrologue8CustomEventForChoiceSet : public VNChoiceEvent {
    protected:
      void onStart() override;
  };

  class ScenePrologue8CustomEventForAfterChoice : public VNEvent {
    protected:
      void onStart() override;
  };
  
  class ScenePrologue8CustomEventForAfterCharacterFollowup : public VNEvent {
    protected:
      void onStart() override;
  };

  class ScenePrologue8 : public SceneMonologue {
    public:
      std::map<std::string, std::string> remainingChoices;

      ScenePrologue8(DawnGame *game);
      
      std::vector<Asset*> getRequiredAssets() override;
      
      void stage() override;
  };
}