// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "EntityShootingAttack.hpp"

using namespace Dawn;

EntityShootingAttack::EntityShootingAttack(SceneItem* item) : EntityAttackBase(item) {
}

void EntityShootingAttack::onStart() {
  EntityAttackBase::onStart();

  useEvent([&] {
    std::cout << "Shoot!" << std::endl;
  }, this->onAttackActiveStart);
}

void EntityShootingAttack::onDispose() {
  EntityAttackBase::onDispose();
}

float_t EntityShootingAttack::getAttackRampUpDuration() {
  return 0.1f;
}

float_t EntityShootingAttack::getAttackActiveDuration() {
  return 0.2f;
}

float_t EntityShootingAttack::getAttackRampDownDuration() {
  return 0.1f;
}

float_t EntityShootingAttack::getAttackCooldownDuration() {
  return 0.0f;
}

bool_t EntityShootingAttack::isInterruptable() {
  return false;
}

bool_t EntityShootingAttack::canAttack() {
  return true;
}